Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class Untyped

    java.lang.Object
      net.sf.saxon.type.Untyped

All Implemented Interfaces:
  Serializable, ComplexType, SchemaComponent, SchemaType

    public final class Untyped

extends Object
implements ComplexType, Serializable

This class has a singleton instance which represents the complex type xdt:untyped, used for elements that have not been validated.

See Also:
  Serialized Form

Field Summary

Fields inherited from interface net.sf.saxon.type.ComplexType
`OPEN_CONTENT_ABSENT, OPEN_CONTENT_INTERLEAVE, OPEN_CONTENT_NONE, OPEN_CONTENT_SUFFIX, VARIETY_ELEMENT_ONLY, VARIETY_EMPTY, VARIETY_MIXED, VARIETY_SIMPLE`

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Method Summary
`boolean` | `allowsAttributes()` Return true if this type (or any known type derived from it by extension) allows the element to have one or more attributes.
`boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
`void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`Value` | `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`void` | `checkTypeDerivationIsOK(SchemaType type, int block)` Check that this type is validly derived from a given type
`boolean` | `containsElementWildcard()` Ask whether this type (or any known type derived from it by extension) allows the element to have children that match a wildcard
`void` | `gatherAllPermittedChildren(IntHashSet children, boolean ignoreWildcards)` Get a list of all the names of elements that can appear as children of an element having this complex type, as integer fingerprints.
`void` | `gatherAllPermittedDescendants(IntHashSet descendants)` Get a list of all the names of elements that can appear as descendants of an element having this complex type, as integer fingerprints.
`int` | `getAttributeUseCardinality(int fingerprint)` Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the cardinality associated with that attribute, which will always be 0, 1, or 0-or-1.
`SimpleType` | `getAttributeUseType(int fingerprint)` Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the schema type associated with that attribute.
`SchemaType` | `getBaseType()` Returns the base type that this type inherits from.
`int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
`int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
`int` | `getDescendantElementCardinality(int fingerprint)` Assuming an element is a permitted descendant in the content model of this type, determine the cardinality of the element when it appears as a descendant.
`SchemaType` | `getDescendantElementType(int fingerprint)` Assuming an element is a permitted descendant in the content model of this type, determine the type of the element when it appears as a descendant.
`String` | `getDescription()` Get a description of this type for use in diagnostics
`String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
`int` | `getElementParticleCardinality(int fingerprint, boolean considerExtensions)` Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the cardinality associated with that element particle, that is, the number of times the element can occur within this complex type.
`SchemaType` | `getElementParticleType(int fingerprint, boolean considerExtensions)` Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the schema type associated with that element particle.
`int` | `getFingerprint()` Get the fingerprint of the name of this type
`static Untyped` | `getInstance()` Get the singular instance of this class
`SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
`String` | `getName()` Get the local name of this type
`int` | `getNameCode()` Get the namecode of the name of this type.
`int` | `getRedefinitionLevel()` Get the redefinition level.
`SimpleType` | `getSimpleContentType()` For a complex type with simple content, return the simple type of the content.
`String` | `getSystemId()` Get the URI of the schema document containing the definition of this type
`String` | `getTargetNamespace()` Get the target namespace of this type
`SequenceIterator` | `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type
`int` | `getValidationStatus()` Get the validation status - always valid
`int` | `getVariety()` Get the variety of this complex type.
`boolean` | `isAbstract()` Test whether this ComplexType has been marked as abstract.
`boolean` | `isAllContent()` Test whether this complex type has "all" content, that is, a content model using an xs:all compositor
`boolean` | `isAnonymousType()` Test whether this is an anonymous type
`boolean` | `isAtomicType()` Test whether this SchemaType is an atomic type
`boolean` | `isComplexContent()` Test whether this complex type has complex content
`boolean` | `isComplexType()` Test whether this SchemaType is a complex type
`boolean` | `isEmptiable()` Test whether the content model of this complexType allows empty content
`boolean` | `isEmptyContent()` Test whether the content type of this complex type is empty
`boolean` | `isIdRefType()` Ask whether this type is an IDREF or IDREFS type.
`boolean` | `isIdType()` Ask whether this type is an ID type.
`boolean` | `isMixedContent()` Test whether this complex type allows mixed content
`boolean` | `isRestricted()` Test whether this complex type is derived by restriction
`boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
`boolean` | `isSimpleContent()` Test whether this complex type has simple content
`boolean` | `isSimpleType()` Test whether this SchemaType is a simple type

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getValidationStatus

    public int getValidationStatus()

  Get the validation status - always valid

  Specified by:
    `getValidationStatus` in interface `SchemaComponent`
  Returns:
    one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

### getName

    public String getName()

  Get the local name of this type

  Specified by:
    `getName` in interface `SchemaType`
  Returns:
    the local name of this type definition, if it has one. Return null in the case of an anonymous type.

### getRedefinitionLevel

    public int getRedefinitionLevel()

  Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.

  Specified by:
    `getRedefinitionLevel` in interface `SchemaComponent`
  Returns:
    the redefinition level

### getTargetNamespace

    public String getTargetNamespace()

  Get the target namespace of this type

  Specified by:
    `getTargetNamespace` in interface `SchemaType`
  Returns:
    the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

### getVariety

    public int getVariety()

  Get the variety of this complex type. This will be one of the values `ComplexType.VARIETY_EMPTY`, `ComplexType.VARIETY_MIXED`, `ComplexType.VARIETY_SIMPLE`, or `ComplexType.VARIETY_ELEMENT_ONLY`

  Specified by:
    `getVariety` in interface `ComplexType`

### getSystemId

    public String getSystemId()

  Get the URI of the schema document containing the definition of this type

  Specified by:
    `getSystemId` in interface `SchemaType`
  Returns:
    null for a built-in type

### getBlock

    public int getBlock()

  Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`

  Specified by:
    `getBlock` in interface `SchemaType`
  Returns:
    the value of the 'block' attribute for this type

### getDerivationMethod

    public int getDerivationMethod()

  Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.

  Specified by:
    `getDerivationMethod` in interface `SchemaType`
  Returns:
    a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

### allowsDerivation

    public boolean allowsDerivation(int derivation)

  Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property

  Specified by:
    `allowsDerivation` in interface `SchemaType`
  Parameters:
    `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
  Returns:
    true if this kind of derivation is allowed

### checkTypeDerivationIsOK

    public void checkTypeDerivationIsOK(SchemaType type,
                                        int block)

  Check that this type is validly derived from a given type

  Specified by:
    `checkTypeDerivationIsOK` in interface `SchemaType`
  Parameters:
    `type` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of this type

  Specified by:
    `getFingerprint` in interface `SchemaType`
  Returns:
    the fingerprint. Returns an invented fingerprint for an anonymous type.

### getNameCode

    public int getNameCode()

  Get the namecode of the name of this type. This includes the prefix from the original type declaration: in the case of built-in types, there may be a conventional prefix or there may be no prefix.

  Specified by:
    `getNameCode` in interface `SchemaType`
  Returns:
    the namecode. Returns an invented namecode for an anonymous type.

### getDisplayName

    public String getDisplayName()

  Get the display name of the type: that is, a lexical QName with an arbitrary prefix

  Specified by:
    `getDisplayName` in interface `SchemaType`
  Returns:
    a lexical QName identifying the type

### isComplexType

    public boolean isComplexType()

  Test whether this SchemaType is a complex type

  Specified by:
    `isComplexType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a complex type

### isAnonymousType

    public boolean isAnonymousType()

  Test whether this is an anonymous type

  Specified by:
    `isAnonymousType` in interface `SchemaType`
  Returns:
    true if this SchemaType is an anonymous type

### getKnownBaseType

    public SchemaType getKnownBaseType()
                                throws IllegalStateException

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Returns:
    the base type.
  Throws:
    `IllegalStateException` - if this type is not valid.

### isSameType

    public boolean isSameType(SchemaType other)

  Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)

  Specified by:
    `isSameType` in interface `SchemaType`
  Parameters:
    `other` - the other type
  Returns:
    true if this is the same type as other

### getBaseType

    public SchemaType getBaseType()

  Returns the base type that this type inherits from. If this type is a Simpletype that is a built in primitive type then null is returned.

  Specified by:
    `getBaseType` in interface `SchemaType`
  Returns:
    the base type.

### getInstance

    public static Untyped getInstance()

  Get the singular instance of this class

  Returns:
    the singular object representing xs:anyType

### isAbstract

    public boolean isAbstract()

  Test whether this ComplexType has been marked as abstract.

  Specified by:
    `isAbstract` in interface `ComplexType`
  Returns:
    false: this class is not abstract.

### isSimpleType

    public boolean isSimpleType()

  Test whether this SchemaType is a simple type

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a simple type

### isAtomicType

    public boolean isAtomicType()

  Test whether this SchemaType is an atomic type

  Specified by:
    `isAtomicType` in interface `SchemaType`
  Returns:
    true if this SchemaType is an atomic type

### isIdType

    public boolean isIdType()

  Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list.

  Specified by:
    `isIdType` in interface `SchemaType`
  Returns:
    true if this type is an ID type

### isIdRefType

    public boolean isIdRefType()

  Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union

  Specified by:
    `isIdRefType` in interface `SchemaType`
  Returns:
    true if this type is an IDREF type

### isComplexContent

    public boolean isComplexContent()

  Test whether this complex type has complex content

  Specified by:
    `isComplexContent` in interface `ComplexType`
  Returns:
    true: this complex type has complex content

### isSimpleContent

    public boolean isSimpleContent()

  Test whether this complex type has simple content

  Specified by:
    `isSimpleContent` in interface `ComplexType`
  Returns:
    false: this complex type has complex content

### isAllContent

    public boolean isAllContent()

  Test whether this complex type has "all" content, that is, a content model using an xs:all compositor

  Specified by:
    `isAllContent` in interface `ComplexType`
  Returns:
    false: this complex type does not use an "all" compositor

### getSimpleContentType

    public SimpleType getSimpleContentType()

  For a complex type with simple content, return the simple type of the content. Otherwise, return null.

  Specified by:
    `getSimpleContentType` in interface `ComplexType`
  Returns:
    null: this complex type does not have simple content

### isRestricted

    public boolean isRestricted()

  Test whether this complex type is derived by restriction

  Specified by:
    `isRestricted` in interface `ComplexType`
  Returns:
    true: this type is treated as a restriction of xs:anyType

### isEmptyContent

    public boolean isEmptyContent()

  Test whether the content type of this complex type is empty

  Specified by:
    `isEmptyContent` in interface `ComplexType`
  Returns:
    false: the content model is not empty

### isEmptiable

    public boolean isEmptiable()

  Test whether the content model of this complexType allows empty content

  Specified by:
    `isEmptiable` in interface `ComplexType`
  Returns:
    true: the content is allowed to be empty

### isMixedContent

    public boolean isMixedContent()

  Test whether this complex type allows mixed content

  Specified by:
    `isMixedContent` in interface `ComplexType`
  Returns:
    true: mixed content is allowed

### getDescription

    public String getDescription()

  Get a description of this type for use in diagnostics

  Specified by:
    `getDescription` in interface `SchemaType`
  Returns:
    the string "xs:anyType"

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` - the static context

### getTypedValue

    public SequenceIterator getTypedValue(NodeInfo node)

  Get the typed value of a node that is annotated with this schema type

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    an iterator returning a single untyped atomic value, equivalent to the string value of the node. This follows the standard rules for elements with mixed content.

### atomize

    public Value atomize(NodeInfo node)

  Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method `getTypedValue(net.sf.saxon.om.NodeInfo)`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    the typed value.
  Since:
    8.5

### getElementParticleType

    public SchemaType getElementParticleType(int fingerprint,
                                             boolean considerExtensions)

  Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the schema type associated with that element particle. If there is no such particle, return null. If the fingerprint matches an element wildcard, return the type of the global element declaration with the given name if one exists, or AnyType if none exists and lax validation is permitted by the wildcard.

  Specified by:
    `getElementParticleType` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
    `considerExtensions` -
  Returns:
    the schema type associated with the child element particle with the given name. If there is no such particle, return null.

### getElementParticleCardinality

    public int getElementParticleCardinality(int fingerprint,
                                             boolean considerExtensions)

  Find an element particle within this complex type definition having a given element name (identified by fingerprint), and return the cardinality associated with that element particle, that is, the number of times the element can occur within this complex type. The value is one of `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, If there is no such particle, return zero.

  Specified by:
    `getElementParticleCardinality` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
    `considerExtensions` -
  Returns:
    the cardinality associated with the child element particle with the given name. If there is no such particle, return `StaticProperty.EMPTY`.

### getAttributeUseType

    public SimpleType getAttributeUseType(int fingerprint)

  Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the schema type associated with that attribute. If there is no such attribute use, return null. If the fingerprint matches an attribute wildcard, return the type of the global attribute declaration with the given name if one exists, or AnySimpleType if none exists and lax validation is permitted by the wildcard.

  Specified by:
    `getAttributeUseType` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
  Returns:
    the schema type associated with the attribute use identified by the fingerprint. If there is no such attribute use, return null.

### getAttributeUseCardinality

    public int getAttributeUseCardinality(int fingerprint)
                                   throws SchemaException

  Find an attribute use within this complex type definition having a given attribute name (identified by fingerprint), and return the cardinality associated with that attribute, which will always be 0, 1, or 0-or-1. If there is no such attribute use, return null. If the fingerprint matches an attribute wildcard, return the type of the global attribute declaration with the given name if one exists, or AnySimpleType if none exists and lax validation is permitted by the wildcard.

  If there are types derived from this type by extension, search those too.

  Specified by:
    `getAttributeUseCardinality` in interface `ComplexType`
  Parameters:
    `fingerprint` - Identifies the name of the child element within this content model
  Returns:
    the schema type associated with the attribute use identified by the fingerprint. If there is no such attribute use, return null.
  Throws:
    `SchemaException`

### allowsAttributes

    public boolean allowsAttributes()

  Return true if this type (or any known type derived from it by extension) allows the element to have one or more attributes.

  Specified by:
    `allowsAttributes` in interface `ComplexType`
  Returns:
    true if attributes are allowed

### gatherAllPermittedChildren

    public void gatherAllPermittedChildren(IntHashSet children,
                                           boolean ignoreWildcards)
                                    throws SchemaException

  Get a list of all the names of elements that can appear as children of an element having this complex type, as integer fingerprints. If the list is unbounded (because of wildcards or the use of xs:anyType), return null.

  Specified by:
    `gatherAllPermittedChildren` in interface `ComplexType`
  Parameters:
    `children` - an integer set, initially empty, which on return will hold the fingerprints of all permitted child elements; if the result contains the value -1, this indicates that it is not possible to enumerate all the children, typically because of wildcards. In this case the other contents of the set should
    `ignoreWildcards` -
  Throws:
    `SchemaException`

### gatherAllPermittedDescendants

    public void gatherAllPermittedDescendants(IntHashSet descendants)
                                       throws SchemaException

  Get a list of all the names of elements that can appear as descendants of an element having this complex type, as integer fingerprints. If the list is unbounded (because of wildcards or the use of xs:anyType), return null.

  Specified by:
    `gatherAllPermittedDescendants` in interface `ComplexType`
  Parameters:
    `descendants` - an integer set, initially empty, which on return will hold the fingerprints of all permitted descendant elements; if the result contains the value -1, this indicates that it is not possible to enumerate all the descendants, typically because of wildcards. In this case the other contents of the set should be ignored.
  Throws:
    `SchemaException`

### getDescendantElementType

    public SchemaType getDescendantElementType(int fingerprint)
                                        throws SchemaException

  Assuming an element is a permitted descendant in the content model of this type, determine the type of the element when it appears as a descendant. If it appears with more than one type, return xs:anyType.

  Specified by:
    `getDescendantElementType` in interface `ComplexType`
  Parameters:
    `fingerprint` - the name of the required descendant element
  Returns:
    the type of the descendant element; null if the element cannot appear as a descendant; anyType if it can appear with several different types
  Throws:
    `SchemaException`

### getDescendantElementCardinality

    public int getDescendantElementCardinality(int fingerprint)
                                        throws SchemaException

  Assuming an element is a permitted descendant in the content model of this type, determine the cardinality of the element when it appears as a descendant.

  Specified by:
    `getDescendantElementCardinality` in interface `ComplexType`
  Parameters:
    `fingerprint` - the name of the required descendant element
  Returns:
    the cardinality of the descendant element within this complex type
  Throws:
    `SchemaException`

### containsElementWildcard

    public boolean containsElementWildcard()

  Ask whether this type (or any known type derived from it by extension) allows the element to have children that match a wildcard

  Specified by:
    `containsElementWildcard` in interface `ComplexType`
  Returns:
    true if the content model of this type, or its extensions, contains an element wildcard

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.